package com.jcraft.jsch.agentproxy.eclipse.sshagent;
/*
Copyright (c) 2012 ymnk, JCraft,Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright 
     notice, this list of conditions and the following disclaimer in 
     the documentation and/or other materials provided with the distribution.

  3. The names of the authors may not be used to endorse or promote products
     derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,
INC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

import java.io.File;
import java.io.IOException;
import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.jsch.core.IAgentProxyConnectorFactory;

import com.jcraft.jsch.agentproxy.AgentProxyException;
import com.jcraft.jsch.agentproxy.Buffer;
import com.jcraft.jsch.agentproxy.Connector;
import com.jcraft.jsch.agentproxy.USocketFactory;
import com.jcraft.jsch.agentproxy.connector.SSHAgentConnector;
import com.jcraft.jsch.agentproxy.usocket.JUnixDomainSocketFactory;

public class SSHAgentConnectorFactory implements IAgentProxyConnectorFactory{

	public SSHAgentConnectorFactory() {
		// TODO Auto-generated constructor stub
	}

	public Connector create() {

		try {
			try{
				String lib = System.getProperty("org.newsclub.net.unix.library.path");
				if (lib == null) {
					URL base = Platform.getBundle("com.jcraft.jsch.agentproxy.eclipse.sshagent").getEntry("lib");
					lib = FileLocator.toFileURL(base).toString();
					if (lib.startsWith("file:"))
						lib = lib.substring(5);
				}
				if (lib != null)
					System.setProperty("org.newsclub.net.unix.library.path", lib);
			} catch (IOException e) {
			}
	        USocketFactory usf = new JUnixDomainSocketFactory();
	        Connector con = new SSHAgentConnector(usf);
			return con;
		} catch (AgentProxyException e) {
		}

		return new Connector() {
			public String getName() {
				return "ssh-agent";
			}

			public boolean isAvailable() {
				return false;
			}

			public void query(Buffer arg0) throws AgentProxyException {
				/* */
			}
		};
	}

}
